// sNZVF[_[̓
struct PS_INPUT
{
	float2 TexCoords0      : TEXCOORD0 ;
	float  Fog             : TEXCOORD1 ;		// tHOp[^
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0           : SV_TARGET0 ;	// F
} ;


// }eAp[^
struct DX_D3D11_CONST_MATERIAL
{
	float4		Diffuse ;				// fBt[YJ[
	float4		Specular ;				// XyLJ[
	float4		Ambient_Emissive ;		// }eAG~bVuJ[ + }eAArGgJ[ * O[oArGgJ[

	float		Power ;					// XyL̋
	float		TypeParam0 ;			// }eA^Cvp[^0
	float		TypeParam1 ;			// }eA^Cvp[^1
	float		TypeParam2 ;			// }eA^Cvp[^2
} ;

// tHOp[^
struct DX_D3D11_VS_CONST_FOG
{
	float		LinearAdd ;				// tHOpp[^ end / ( end - start )
	float		LinearDiv ;				// tHOpp[^ -1  / ( end - start )
	float		Density ;				// tHOpp[^ density
	float		E ;						// tHOpp[^ Rΐ̒

	float4		Color ;					// J[
} ;

// Cgp[^
struct DX_D3D11_CONST_LIGHT
{
	int			Type ;					// Cg^Cv( DX_LIGHTTYPE_POINT Ȃ )
	int3		Padding1 ;				// pfBOP

	float3		Position ;				// W( r[ )
	float		RangePow2 ;				// L̂Q

	float3		Direction ;				// ( r[ )
	float		FallOff ;				// X|bgCgpFallOff

	float3		Diffuse ;				// fBt[YJ[
	float		SpotParam0 ;			// X|bgCgpp[^O( cos( Phi / 2.0f ) )

	float3		Specular ;				// XyLJ[
	float		SpotParam1 ;			// X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )

	float4		Ambient ;				// ArGgJ[ƃ}eÃArGgJ[Z

	float		Attenuation0 ;			// ɂ錸pp[^O
	float		Attenuation1 ;			// ɂ錸pp[^P
	float		Attenuation2 ;			// ɂ錸pp[^Q
	float		Padding2 ;				// pfBOQ
} ;

// sNZVF[_[E_VF[_[ʃp[^
struct DX_D3D11_CONST_BUFFER_COMMON
{
	DX_D3D11_CONST_LIGHT		Light[ 6 ] ;			// Cgp[^
	DX_D3D11_CONST_MATERIAL		Material ;				// }eAp[^
	DX_D3D11_VS_CONST_FOG		Fog ;					// tHOp[^
} ;

// 萔obt@sNZVF[_[{p[^
struct DX_D3D11_PS_CONST_BUFFER_BASE
{
	float4		FactorColor ;			// At@l

	float		MulAlphaColor ;			// J[ɃAt@lZ邩ǂ( 0.0f:ZȂ  1.0f:Z )
	float		AlphaTestRef ;			// At@eXgŎgprl
	float2		Padding1 ;

	int			AlphaTestCmpMode ;		// At@eXgr[h( DX_CMP_NEVER Ȃ )
	int3		Padding2 ;

	float4		IgnoreTextureColor ;	// eNX`J[pJ[
} ;

// _VF[_[EsNZVF[_[ʃp[^
cbuffer cbD3D11_CONST_BUFFER_COMMON					: register( b0 )
{
	DX_D3D11_CONST_BUFFER_COMMON		g_Common ;
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_PS_BASE				: register( b1 )
{
	DX_D3D11_PS_CONST_BUFFER_BASE		g_Base ;
} ;


SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;

	// eNX`J[̓ǂݍ
	TextureDiffuseColor = g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0 ) ;

	// o̓J[ = eNX`J[
	PSOutput.Color0 = TextureDiffuseColor ;

	// tHO
	PSOutput.Color0.rgb = lerp( g_Common.Fog.Color.rgb, PSOutput.Color0.rgb, saturate( PSInput.Fog ) );

	// o̓At@ = eNX`At@ * sx
	PSOutput.Color0.a = TextureDiffuseColor.a * g_Base.FactorColor.a ;

	// o̓p[^Ԃ
	return PSOutput ;
}

